"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Command_1 = __importDefault(require("../../Abstractions/Command"));
class SaveCommand extends Command_1.default {
    constructor() {
        super(...arguments);
        this.Parametrized = true;
        this.Lockdown = true;
        this.Blurb = 'Command for bot owners and allowed users to save running bot data into a datbase if one has been configured';
        this.Arguments = [{ name: 'command' }];
    }
    async Run(message, args) {
        if (message.author.id !== this.BotContext.Owner) {
            message.channel.send('[Permission Failure] This command is only available to owner');
        }
        const { command } = args;
        const modifyingCommand = this.BotContext.LoadedCommands[command.toLowerCase()];
        if (!modifyingCommand) {
            return message.channel.send(`[Error] Command ${command} not found`);
        }
        await modifyingCommand.Save(true);
        return message.channel.send(`[Updated] Command ${command} has been saved`);
    }
}
SaveCommand.NAME = 'saveCommand';
SaveCommand.NAMESPACE = 'util';
exports.default = SaveCommand;
